From 16f5f2ba1dbc31d762277527e3fd3c90ed96f817 Mon Sep 17 00:00:00 2001
From: Francois Andrieu <darknao@fedoraproject.org>
Date: Feb 06 2022 15:41:45 +0000
Subject: [PATCH 76/88] catch git error


---

diff --git a/lib/extensions/page-last-update.js b/lib/extensions/page-last-update.js
index a2bfaf2..e0a1ae5 100644
--- a/lib/extensions/page-last-update.js
+++ b/lib/extensions/page-last-update.js
@@ -1,29 +1,35 @@
 
 module.exports.register = function () {
   this.on('contentClassified', async ({ contentCatalog }) => {
-      const logger = this.require('@antora/logger').get('page-last-update')
-      const git = this.require('@antora/content-aggregator/lib/git')
-      const path = this.require('path')
-      const fs = this.require('fs')
-      // logger.warn(contentCatalog)
+    const logger = this.require('@antora/logger').get('page-last-update')
+    const git = this.require('@antora/content-aggregator/lib/git')
+    const path = this.require('path')
+    const fs = this.require('fs')
+    // logger.warn(contentCatalog)
 
-      const pages = contentCatalog.findBy({ family: 'page' })
-      for (const module of pages) {
-	    const relpath = path.join(module.src.origin.startPath, module.src.path)
-            logger.warn(relpath)
-            // logger.warn(module.src)
-	    const contents = module.contents.toString('utf-8')
+    const pages = contentCatalog.findBy({ family: 'page' })
+    for (const page of pages) {
+      const relpath = path.join(page.src.origin.startPath, page.src.path)
+      logger.warn(relpath)
+      const contents = page.contents.toString('utf-8')
 
-            // logger.warn(module.contents)
-	    const commits = await git.log({ fs, gitdir: module.src.origin.gitdir, filepath: relpath, ref: "origin/"+module.src.origin.refname, follow: true, depth: 1 })
-	    const last_update = new Date(commits[0].commit.author.timestamp * 1000).toISOString().split('T')[0]
-	    const last_author = commits[0].commit.author.name
-            // logger.warn(commits)
-            // logger.warn({ name: relpath, created_at: created_at, last_update: last_update, by: last_author })
-	    const patchedContents = ":page-last-updated: " + last_update + "\n" + contents
-	    module.contents = Buffer.from(patchedContents)
+      // Get git history
+      try {
+        const commits = await git.log({ fs, gitdir: page.src.origin.gitdir, filepath: relpath, ref: "origin/"+page.src.origin.refname, follow: true, depth: 1 })
 
+        // Get last commit date & author
+        const last_update = new Date(commits[0].commit.author.timestamp * 1000).toISOString().split('T')[0]
+        const last_author = commits[0].commit.author.name
+
+        // Inject attribute in page content
+        const patchedContents = ":page-last-updated: " + last_update + "\n" + contents
+        page.contents = Buffer.from(patchedContents)
+      } catch (gitErr) {
+        logger.error("no history found")
+	continue
       }
-      this.updateVariables({ contentCatalog })
-    })
+
+    }
+    this.updateVariables({ contentCatalog })
+  })
 }

